
#include <SDL.h>
#include <SDL_opengl.h>
#include <math.h>

#ifndef M_PI
#define M_PI 3.141592
#endif

#define MUL 128.0

extern unsigned char jamppa[];

void frustraatio(void);
void show(unsigned char *s,char fg,char bg);

extern int counter;
extern char quit;

// texture
#define TW 1024
#define TH 512

// screen
#define W 640.0
#define H 480.0
#define IW 640
#define IH 480

signed short *smp=NULL;

#define AUDIO_LEN 1024

void init(void)
{
    int i;

    for (i=1; i<=1; i++) {
	glBindTexture(GL_TEXTURE_2D,i);
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	glTexImage2D(GL_TEXTURE_2D, 0,
		     GL_RGBA,
		     TW,TH,
		     0,
		     GL_RGB,
		     GL_UNSIGNED_BYTE,
		     NULL
		    );
    }
}

#define X 1.0
#define Y 0.75
#define Z2 (-0.99)

#define LIN 1
#define JAM 2
#define ROT 4
#define RIN 8

#define ROWLEN 6 /* Row len in bytes in script */

/* Beat, fx, rotation speed/dir, shine1, shine2, Brown's head (r,g) */
signed char script[] ={
0,    LIN,          -1, 0,  0,  0,
16/2, LIN,          1,  0,  0,  0,
32/2, JAM+ROT,      -2, 15, 1,  060,
40/2, JAM+ROT,      4,  10, 4,  000,
44/2, JAM+ROT,      -6, 30, 4,  060,
47/2, JAM+ROT,      22, 30, 4,  060,

48/2, JAM+LIN,      3,  25, 3,  060,
64/2, RIN,          0,  80, 1,  0,
68/2, RIN+LIN,      -3, 127, 1, 0,
78/2, RIN,          0,  80, 1,  0,

80/2, JAM+RIN+ROT,  2,  20, 5,  060,
84/2, JAM+RIN+ROT,  -3, 10, 5,  040,
88/2, JAM+LIN,      3,  20, 5,  063,
92/2, JAM+RIN+ROT,  -3, 30, 5,  065,

96/2,  RIN+ROT,     1,  0,  0,  0,
108/2, RIN+ROT,     -2, 10, 5,  0,
112/2, RIN+ROT,     2,  10, 5,  0,
116/2, RIN+ROT,     -2, 10, 5,  0,
120/2, RIN+ROT,     2,  10, 5,  0,
124/2, RIN+ROT,     -1, 0,  0,  0,

254/2, 0,0,0,0,0
};

char osa(int klok)
{
    static int oldframe=0,n,i,j,k;
    float  f,p,p_r;
    static float    p_s1=0,p_s2=0;
    signed char fx,*sk=script,colr;

    int beat=(counter-BLKSIZE)/5292;
    if (beat<0)
	beat=0;
    beat/=8;

    /* Hey hey, not too fast (100Hz) */
    if(klok<oldframe+9)
	return(0); // Frame not drawn
    oldframe=klok;

    /* Search the script */
    while(1)
    {
        if(beat/2<*sk++)
            break;
        fx=*sk++;
        p_r=*sk++;
        p_s1=*sk++/100.0;
        p_s2=*sk++/100.0;
        colr=*sk++;
    }

    /* GL setup */
    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glFrustum(-0.01,0.01, -0.0075,0.0075, 0.01,1135.0);

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    glLineWidth(5);
    glDisable(GL_TEXTURE_2D);
    glDisable(GL_BLEND);

    /* Sample lines */
    if(fx&LIN)
    {
        glRotatef(klok/100.0*p_r,0,0,1);
        glTranslatef(0,-0.9,-0.8);
        if(smp!=NULL)
        {
            for(j=0;j<10;j++)
            {
                glColor3f(1,0.6,j/20.0);
                glBegin(GL_LINE_STRIP);
    
                k=(klok<15000)?AUDIO_LEN*klok/15000:AUDIO_LEN*2;
                for(n=0;n<k;n+=16)
                    glVertex3f(n/400.0-k/800.0,smp[n+AUDIO_LEN-k/2]/200000.0,0);
                glEnd();

                glTranslatef(0,0.2,0);
            }
        }
    }

    /* Rotating plaque */
    if(fx&ROT)
    {
        glLoadIdentity();
        glTranslatef(0,0,-1.0);
        glRotatef(klok/10.0*p_r,0,0.3,1);

        glBegin(GL_POLYGON);
        glColor3f(1,0.9,0.1);
        glVertex3f(0,-50,0);
        glVertex3f(50,-50,0);
        glVertex3f(50,50,0);
        glVertex3f(0,50,0);
        glEnd();
    }

    /* Sample rings */
    if(fx&RIN)
    {
        glLoadIdentity();
        glTranslatef(0,0,-1.0);
        glRotatef(klok/10.0*p_r,0,0.3,1);
        if(smp!=NULL)
        {
            for(i=0;i<12;i++)
            {
                glBegin(GL_LINE_LOOP);
                for(n=0;n<AUDIO_LEN*2;n+=16)
                {
                    if(n<AUDIO_LEN && fx&ROT)
                        glColor3f(0,0,0);
                    else
                        glColor3f(1,0.9,0.1);
                    f=0.2+i/3.0+smp[n]/100000.0;
                    glVertex3f(sin((n/2+i)*(M_PI*2.0/AUDIO_LEN))*f,
                               cos((n/2+i)*(M_PI*2.0/AUDIO_LEN))*f,0);
                }
                glEnd();
            }
        }
    }

    /* James Brown face */
    if(fx&JAM)
    {
        unsigned char c,*s;

        for(i=0;i<5;i++)
        {
            glLoadIdentity();
            f=-1.2+0.7*sin(klok/(3*50.0));
            if(beat>=48 && beat<64)
                f=-3.3+(beat-48)/4*0.85;
            else
                if(i!=2)
                    continue;
            glTranslatef(i*1.6-3.2,0,f);

            s=jamppa;
            while(1)
            {
                c=*s++;
                if(c==255)
                    break;
                n=c&0x7f;
    
                if(c&0x80)
                    glColor3f((colr>>3)/7.0,(colr&7)/7.0,0);
                else
                    glColor3f(1,1,0.5);
    
                glBegin(GL_POLYGON);
                while(n--)
                {
                    glVertex3f((signed char)s[0]/MUL,(signed char)s[1]/MUL,0);
                    s+=2;
                }
                glEnd();
            }
        }
    }

    if(beat<32)
    {
        p_s1=klok/18000.0;
        p_s2=0.012;
    }

    /* Shine effect */
    glEnable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);

    glBindTexture(GL_TEXTURE_2D,1);
    glCopyTexSubImage2D(GL_TEXTURE_2D,0,
			0,0, // destination
			0,0, // source
			W,H
		       );
    glLoadIdentity();
    glBlendFunc(GL_ONE,GL_ONE);

    glColor3f(0.2*p_s1,0.2*p_s1,0.2*p_s1);
    for (i=0; i<20; i++)
    {
        glBegin(GL_QUADS);
        glTexCoord2f(0.0,0.0);
        glVertex3f(-X,-Y,Z2);
        glTexCoord2f(W/TW,0.0);
        glVertex3f(X,-Y,Z2);
        glTexCoord2f(W/TW,H/TH);
        glVertex3f(X,Y,Z2);
        glTexCoord2f(0,H/TH);
        glVertex3f(-X,Y,Z2);
        glEnd();

        glTranslatef(0.0,0.0,p_s2);
    }

    if(beat>147)
	quit++;

    return(1); // Frame drawn
}
